package me.wazup.hideandseek.commands.admin;

import org.bukkit.entity.Player;
import org.bukkit.configuration.file.FileConfiguration;
import java.util.Iterator;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.ChatColor;
import me.wazup.hideandseek.managers.FilesManager;
import java.sql.SQLException;
import me.wazup.hideandseek.Config;
import org.bukkit.Bukkit;
import me.wazup.hideandseek.PlayerData;
import org.bukkit.command.CommandSender;
import me.wazup.hideandseek.Customization;
import me.wazup.hideandseek.HideAndSeek;
import me.wazup.hideandseek.commands.SubCommand;

public class ResetCommand extends SubCommand
{
    public ResetCommand() {
        super("hideandseek.reset", true, "<Player> | All");
    }
    
    public boolean execute(final HideAndSeek hideAndSeek, final Customization customization, final CommandSender commandSender, final String[] array) {
        if (array.length == 1) {
            return false;
        }
        if (array[1].equalsIgnoreCase("all")) {
            for (final String key : hideAndSeek.playerData.keySet()) {
                ((PlayerData)hideAndSeek.playerData.get(key)).reset(Bukkit.getPlayer(key));
            }
            if (Config.getInstance().mysql_enabled) {
                try {
                    hideAndSeek.mysql.getConnection().createStatement().executeUpdate("delete from " + hideAndSeek.mysql.tableName);
                }
                catch (final SQLException ex) {
                    ex.printStackTrace();
                }
            }
            else {
                FilesManager.getInstance().getConfig("players.yml").set("Players", (Object)null);
                FilesManager.getInstance().saveConfig("players.yml");
            }
            Bukkit.broadcastMessage((String)customization.messages.get("stats_reset"));
            commandSender.sendMessage(customization.prefix + ChatColor.GREEN + "Success!" + ChatColor.GOLD + " Everyone stats has been reset!");
        }
        else {
            final Player player = Bukkit.getPlayer(array[1]);
            if (player != null) {
                ((PlayerData)hideAndSeek.playerData.get(player.getName())).reset(player);
                player.sendMessage((String)customization.messages.get("stats_reset"));
                commandSender.sendMessage(customization.prefix + ChatColor.GREEN + "Success!" + ChatColor.YELLOW + " " + player.getName() + ChatColor.GOLD + " stats has been reset!");
            }
            else {
                commandSender.sendMessage(customization.prefix + ChatColor.YELLOW + "Couldn't find that player online, looking up the database...");
                final long currentTimeMillis = System.currentTimeMillis();
                final String s = array[1];
                if (Config.getInstance().mysql_enabled) {
                    new BukkitRunnable() {
                        public void run() {
                            try {
                                if (hideAndSeek.mysql.getConnection().createStatement().executeQuery("select * from " + hideAndSeek.mysql.tableName + " where player_name='" + s + "'").next()) {
                                    hideAndSeek.mysql.getConnection().prepareStatement("delete from " + hideAndSeek.mysql.tableName + " WHERE player_name= '" + s + "';").executeUpdate();
                                    final long lng = System.currentTimeMillis() - currentTimeMillis;
                                    commandSender.sendMessage(customization.prefix + "The player " + ChatColor.YELLOW + s + ChatColor.GOLD + " data has been erased! took " + ChatColor.LIGHT_PURPLE + lng + "ms " + ChatColor.GOLD + "(" + ChatColor.AQUA + lng / 1000L + "s" + ChatColor.GOLD + ") to find the player data");
                                }
                                else {
                                    commandSender.sendMessage((String)customization.messages.get("no_player_found"));
                                }
                            }
                            catch (final SQLException ex) {
                                ex.printStackTrace();
                            }
                        }
                    }.runTaskAsynchronously((Plugin)hideAndSeek);
                }
                else {
                    final FileConfiguration config = FilesManager.getInstance().getConfig("players.yml");
                    if (config.getConfigurationSection("Players") == null || config.getConfigurationSection("Players").getKeys(false).isEmpty()) {
                        commandSender.sendMessage((String)customization.messages.get("no_player_found"));
                        return true;
                    }
                    new BukkitRunnable() {
                        final Iterator<String> players = config.getConfigurationSection("Players").getKeys(false).iterator();
                        boolean found = false;
                        
                        public void run() {
                            int n = 0;
                            while (n < 300 && this.players.hasNext()) {
                                ++n;
                                final String s = this.players.next();
                                final String string = config.getString("Players." + s + ".Name");
                                if (string.equalsIgnoreCase(s)) {
                                    config.set("Players." + s, (Object)null);
                                    FilesManager.getInstance().saveConfig("players.yml");
                                    final long lng = System.currentTimeMillis() - currentTimeMillis;
                                    commandSender.sendMessage(customization.prefix + "The player " + ChatColor.YELLOW + string + ChatColor.GOLD + " data has been erased! took " + ChatColor.LIGHT_PURPLE + lng + "ms " + ChatColor.GOLD + "(" + ChatColor.AQUA + lng / 1000L + "s" + ChatColor.GOLD + ") to find the player data");
                                    this.found = true;
                                    this.cancel();
                                    break;
                                }
                            }
                            if (!this.players.hasNext() && !this.found) {
                                commandSender.sendMessage((String)customization.messages.get("no_player_found"));
                                this.cancel();
                            }
                        }
                    }.runTaskTimerAsynchronously((Plugin)hideAndSeek, 0L, 1L);
                }
            }
        }
        return true;
    }
}
